// CustomerAdministration.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.3. 2007.05.27, 1.4 2008.11.20 1.5 2008.12.15, 2.0 2011.04.30
 * Copyright 2003 by Michael Claudius
 * All rights reserved ?
 */
package Controller;

import Model.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class CustomerAdministration {

    private String oldSortType = "CustomerNo";

    /** Creates a new instance of CustomerAdministration */
    public CustomerAdministration() {
        customerReg = new CustomerRegister();
        customerDAO = new CustomerDAO();
    }

    public CustomerAdministration(CustomerRegister customerReg) {
        this.customerReg = customerReg;

    }
    CustomerRegister customerReg;
    CustomerDAO customerDAO = new CustomerDAO();

    public void init() {
        registerCustomer("1", "Michael", "VIP", 2010);
        registerCustomer("2", "Susan", "Member", 2011);
        registerCustomer("3", "Max", "Child", 2010);
        registerCustomer("4", "Michael", "VIP", 2010);
        registerCustomer("5", "Kasper", "Child", 2011);
        registerCustomer("6", "Mads", "VIP", 2010);
    }

    public boolean registerCustomer(String customerNo, String name, String customerType, int year) {
        Customer c = customerReg.getCustomer(customerNo);
        if (c == null) {
            customerDAO.insertCustomerDB(customerNo, name, customerType, year, 0);
            customerReg.registerCustomer(customerNo, name, customerType, year);
            return true;
        } else {
            return false;
        }
    }

    public boolean addCustomer(Customer c) {
        customerReg.addCustomer(c);
        customerDAO.addCustomerDB(c);
        return true;
    }

    public Customer getCustomer(String customerNo) {
        Customer c = customerReg.getCustomer(customerNo);
        if (c != null) {
            System.out.println("Eager search used");
            return c;
        } else {
            return customerDAO.getCustomerDB(customerNo);
        }
        // return customerReg.getCustomer(customerNo);
    }

    public Customer removeCustomer(String customerNo) {
        customerReg.removeCustomer(customerNo);
        return customerDAO.deleteCustomerDB(customerNo);

    }

    public void editCustomer(String customerNo, String newCustomerNo, String name, String customerType, int year, int stays) {
        customerReg.editCustomer(customerNo, newCustomerNo, name, customerType, year, stays);
        Customer customer = new Customer(newCustomerNo, name, customerType, year, stays);
        customerDAO.upDateCustomerDB(customerNo, customer);
    }

    public boolean editCustomer1(Customer oldCustomer, Customer newCustomer) {
        return customerReg.editCustomer1(oldCustomer, newCustomer);
    }

    public int getNumbers() {
        return customerDAO.numberOfCustomers();
        //return customerReg.numberOfCustomers();
    }

    public String allCustomersData() {
        customerReg = customerDAO.getAllCustomersAsRegister();
        return customerReg.toString();
    }

    public ArrayList<Customer> listCustomersData() {
        customerReg = customerDAO.getAllCustomersAsRegister();
        ArrayList<Customer> list = customerReg.getAllCustomers();
        Collections.sort(list);
        return list;
    }

//    public ArrayList<Customer> showCustomersData() {
//        ArrayList<Customer> list = customerReg.getAllCustomers();
//        Collections.sort(list);
//        return list;
//    }

    public ArrayList<Customer> sort(String newSortType, ArrayList cList) {
        if (newSortType.equals(oldSortType)) {
            return cList;
        }
        else {
        oldSortType = newSortType;
//        customerReg = customerDAO.getAllCustomersAsRegister();
//        ArrayList<Customer> cList = customerReg.getAllCustomers();
        if (newSortType.equals("CustomerNo")) Collections.sort(cList);
        if (newSortType.equals("Name")) Collections.sort(cList, new ComparatorName());
        if (newSortType.equals("CustomerType")) Collections.sort(cList, new ComparatorMemberType());
        if (newSortType.equals("Year")) {System.out.println("Sorter efter year");Collections.sort(cList, new ComparatorYear());}
        return cList;
        }
    }
}
