package Controller;

// CustomerTextFiles.java

/* Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0. 2010.11.20
 * Copyright 2003 by Michael Claudius
 * All rights reserved
 */

//package Controller;

import java.io.*;
import Model.*;

public class CustomerTextFiles {

    private Customer aCustomer;
    private CustomerRegister customerReg;
    private String fileName;

    public CustomerTextFiles(CustomerRegister customerReg, String fileName) {
        this.customerReg = customerReg;
        this.fileName = fileName;
    }

    public void doWrite() {
        try {
            FileWriter oos = new FileWriter(new File(fileName));
            int number = customerReg.numberOfCustomers();
            // oos.write(number);
            for (int index = 0; index < number; index++) {
                aCustomer = customerReg.getCustomer(index);
                oos.write(aCustomer.toString());
            } //for
            oos.close();
        }//try
        catch (IOException ex) {
            //System.out.println(ex.getMessage());
            ex.printStackTrace();
        }
    }// doIt

     public void doRead() {

        try {
            FileReader fileRead = new FileReader(new File (fileName));
            BufferedReader bufRead = new BufferedReader(fileRead);

            int lineNo = 1;
            String line = bufRead.readLine();
            while (line != null) {
                System.out.println(lineNo +"  " +line);
                lineNo++;
                line = bufRead.readLine();
            } //while

            bufRead.close();
        }//try

        catch (IOException ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace();
        }

    }//



    public static void main(String[] args) {

        CustomerRegister customerReg = new CustomerRegister();

        Customer b1 = new Customer("150561-7777", "TheBIGBoss", "Adult", 2005);
        Customer b2 = new Customer("15081-7777", "Zhen Zhao", "Adult", 2005);
        Customer b3 = new Customer("10080-7777", "Vaida Caiser", "Adult", 2005);

        customerReg.addCustomer(b1);
        customerReg.addCustomer(b2);
        customerReg.addCustomer(b3);

        System.out.println(customerReg.toString());

        //String fileName = "H:" + "\\" + "SW-Construction" + "\\" + "Solutions" + "\\" + "borrower.data";
        String fileName = "C:" + "\\" + "D Drive" + "\\" + "Undervisning" + "\\" + "Prog1" + "\\" + "Solutions" + "\\"
                + "customerZ.data";
        CustomerTextFiles ctfHandler = new CustomerTextFiles(customerReg, fileName);
        ctfHandler.doWrite();

        ctfHandler.doRead();


    }
}// class

