/* CustomerSQL Version 1.5
 * Copyright 1999 Michael Claudius, Inc. All Rights Reserved.
 * Last modified 2003.10.19, 2005.11.13, 2009.04.13
 * All rights reserved
 */
package Model;

import Utility.DBTool;
import java.sql.*;

public class CustomerDAO {
    //Alternative to create DBTool in each method is to use an instance of the class directly...

    DBTool dbt;
    Statement stmt;
    Connection con;

   public  CustomerDAO() {
        //if you dont want to open/close only once per "use case" then use these
        dbt = new DBTool();
        con = dbt.getConnection();
        stmt = dbt.getStatement();
    }

    public int numberOfCustomers() {
        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();
        int no = 0;
        try {
            String customerQuery = "select count(customerNo) from  customer";
            ResultSet rs = stmt.executeQuery(customerQuery);
            if (rs.next()) {
                no = rs.getInt(1);
            }
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
            dbt.close();
        }
        dbt.close();
        return no;
    }

    public void addCustomerDB(Customer aCustomer) {
        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();

        try {
            String customerInsert = "insert into Customer values ( " + aCustomer.toDBString() + ")";
            stmt.executeUpdate(customerInsert);
        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
            dbt.close();
        }
        dbt.close();
    }

    public void insertCustomerDB(String customerNo, String name, String customerType, int year, int stays) {

        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();
        try {
            String customerInsert = "insert into Customer values (?,?,?,?,?)";
            PreparedStatement prepStmt = con.prepareStatement(customerInsert);

            prepStmt.setString(1, customerNo);
            prepStmt.setString(2, name);
            prepStmt.setInt(3, year);
            prepStmt.setString(4, customerType);
            prepStmt.setInt(5, stays);

            prepStmt.executeUpdate();

            prepStmt.close();
        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
            dbt.close();
        }
        dbt.close();
    }

    public Customer getCustomerDB(String aCustomerNo) {
        String customerNo, name, customerType, state;
        int year, stays;
        Customer customer = null;
        String customerSelect = "select * from Customer where customerNo = " + "\'" + aCustomerNo + "\'";
        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();
        try {
            ResultSet rs = stmt.executeQuery(customerSelect);
            if (rs.next()) {
                customerNo = rs.getString(1);
                name = rs.getString(2);
                year = rs.getInt("year");
                customerType = rs.getString("CType");
                stays = rs.getInt(5);

                customer = new Customer(customerNo, name, customerType, year);
                customer.setNoOfStays(stays);
            }
        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
            dbt.close();
        }

        dbt.close();
        //System.out.println("returning customer");
        return customer;
    }

    public void upDateCustomerDB(String oldCustomerNo, Customer aCustomer) {
        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();
        try {
            //String customerNo = aCustomer.getCustomerNo();
            String customerUpdate = " update Customer set " + aCustomer.toDBUpdateString()
                    + " where customerNo = " + "\'" + oldCustomerNo + "\'";
            stmt.executeUpdate(customerUpdate);
        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
            dbt.close();
        }
        dbt.close();
    }

    public Customer deleteCustomerDB(String aCustomerNo) {
        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();
        Customer customer = getCustomerDB(aCustomerNo);
        if (customer != null) {

            try {
                String customerDelete = "delete from Customer where customerNo = " + "\'" + aCustomerNo + "\'";
                stmt.executeUpdate(customerDelete);
            } catch (SQLException ex) {
                System.err.println(ex.getMessage());
                dbt.close();
            }
        }//if
        dbt.close();
        return customer;
    }

    public ResultSet getAllCustomersAsResultSet() {
        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();
        ResultSet rs = null;

        try {
            String customerSelect = "select * from Customer";
            rs = stmt.executeQuery(customerSelect);
        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
            dbt.close();
        }
        //dbt.close(); DONT close dbt because then ResultSet cannot operate
        return rs;
    }

    public CustomerRegister getAllCustomersAsRegister() {
        String customerNo, name, customerType;
        int year, stays;
        Customer customer;
        CustomerRegister customers = new CustomerRegister();

        DBTool dbt = new DBTool();
        Statement stmt = dbt.getStatement();

        String customerSelect = "select * from Customer";
        try {
            ResultSet rs = stmt.executeQuery(customerSelect);
            while (rs.next()) {
                customerNo = rs.getString(1);
                name = rs.getString(2);
                year = rs.getInt(3);
                customerType = rs.getString(4);
                stays = rs.getInt(5);

                customer = new Customer(customerNo, name, customerType, year, stays);
                customers.addCustomer(customer);
            }

        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
            dbt.close();
        }
        dbt.close();
        return customers;
    }
}// CustomerSQL

