/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Utility;

/**
 *
 * @author michaelc
 */



import Utility.DBTool;
import java.sql.*;
import java.util.*;
import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class PropertyExample {

    private static Connection instance = null;

    /** Creates a new instance of DBConnector */
    private PropertyExample() {
    }

    public static Connection getInstance() throws SQLException{
        if (instance == null){
            instance = makeInstance();
        }
        return instance;
    }


    private static Connection makeInstance() throws SQLException{
        final String FILENAME = "DBTool.properties";

        try {
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(DBTool.class.getName()).log(Level.SEVERE, null, ex);
        }

//        You could also do this:
//        Driver driver = new com.microsoft.sqlserver.jdbc.SQLServerDriver();  // 2005-server
//        DriverManager.registerDriver(driver);
//        System.out.println("Driver loaded : " + driver);

        // properties from the book p. 938
        Properties props = new Properties();
        try {
            FileInputStream fin = new FileInputStream(FILENAME);
            props.load(fin);
        } catch (FileNotFoundException fnfe) {
            throw new SQLException("Proporty file not found (was " + FILENAME + ")");
        }catch (IOException ex) {
            throw new SQLException("Proporty file not readable");
        }

        String url  = props.getProperty("jdbc.url");
        String user = props.getProperty("jdbc.username");
        String pass = props.getProperty("jdbc.password");

        System.out.println("DB props " + url + " " + user + " " + pass);
        // reading properties ended

        Connection conn = DriverManager.getConnection( url, user, pass );

        return conn;
    }

}

